<?php

defined ('_JEXEC') or die('Restricted access');

/**
 * Plugin providing Custom variables for the VM Ordernumber plugin
 *
 * @copyright Copyright (C) 2014 Reinhold Kainhofer, office@open-tools.net
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 *
 * http://open-tools.net/
 *
 */
if (!class_exists('vmShopperPlugin')) 
    require(JPATH_VM_PLUGINS . DS . 'vmshopperplugin.php');

/** Extension plugin for the Ordernumber plugin for VirtueMart
 */
class plgVmShopperYOUR_PLUGIN_NAME extends VmShopperPlugin {
    // Unfortunately, this dummy function needs to be implementd, because it's abstract in the parent class!
    public function plgVmOnUpdateOrderBEShopper($_orderID) {}

	/**  Trigger to add variables to be used in the number formats
	  *  You can add new variables to the $cartvals array or modify existing ones. They will be directly 
	  *  available in all formats. This trigger will be called whenever the ordernumber plugin creates a 
	  *  number. All built-in variables are already set in the $reps variable, so you can even override
	  *  the built-in variables by changing $reps accordingly.
	  *  $nrtype is 0 for ordernumber, 1 for invoice number, 2 for customer number and 3 for order password
	  *  $details contains the order details
	  */
	function onVmOrdernumberGetVariables(&$reps, $fmt, $nrtype, $details) {
        // As an example add a variable [type] that contains the number type:
        switch ($nrtype) {
            case 0: $reps['[type]'] = "Order"; break;
            case 1: $reps['[type]'] = "Invoice"; break;
            case 2: $reps['[type]'] = "Customer"; break;
            case 3: $reps['[type]'] = "OrderPassword"; break;
        }
        // Another example: set the ip address:
        if (isset($details->ip_address)) $reps["[ipaddress]"] = $details->ip_address;
        // You can also modify existing variables:
        $reps['[second]'] = $reps['[second]'] + 15;
	}

	/**  Trigger to postprocess generated numbers (e.g. to add checksums or call 
	  *  external bookkeeping systems to store an invoice number).
	  *  The number can be changed by simply assigning a new value to $number.
	  *
	  *  Possible values for $type are "order_number", "order_password", "invoice_number", "customer_number", etc.
	  */
	function onVmOrdernumberPostprocessNumber(&$number, $type, $order) {
		// Example: Append the length of the number to the number
		if ($type=="order_number") {
			$checksum=strlen($number);
			$number .= $checksum;
		}
		// Example 2: Store the invoice number in an external bookkeeping system
		if ($type=="invoice_number") {
			// simply take $number and trigger a webservice call sending that value 
			// (and e.g. the order ID stored in the $order object) to the bookkeeping system
		}
	}

}

// No closing tag
